note
	description: "[
		Test examples with arrays and regular expressions.
		First test fails as Result is False by default.
		Write your own tests.
		Included libraries:
			base and extension
			Espec unit testing
			Mathmodels
			Gobo structures
			Gobo regular expressions
		]"
	author: "JSO"
	date: "$Date$"
	revision: "$Revision 19.05$"

class
	TEST_EXAMPLE

inherit

	ES_TEST

create
	make

feature {NONE} -- Initialization

	make
			-- initialize tests
		do
			add_boolean_case (agent t0)
			add_boolean_case (agent t1)
		end

feature -- tests

	t0: BOOLEAN
		local
			names: ARRAY[STRING]
		do
			comment ("t0: testing across")
			create names.make_empty
			-- names.count = 0
			names.force ("alan", names.count + 1)
			names.force ("mark", names.count + 1)
			names.force ("tom", names.count + 1)
			Result := names.count = 3 and names.lower = 1 and names.upper = 3

			-- Are all the strings stored non-empty?
			Result :=
				across
					names is n -- dummy varaible of type string
				all -- universal quantification
					not n.is_empty -- name.count /= 0
				end

			-- add 10 empty strings into the array
			across
				1 |..| 10 is i
			loop
				names.force ("", names.count + 1)
			end
			Result := names.count = 13
		end

	t1: BOOLEAN
		local
			ns: LINKED_LIST[INTEGER]
			is_sorted: BOOLEAN
		do
			comment ("t1: more across examples")
			create ns.make
			ns.extend (23)
			ns.extend (89)
			ns.extend (14)

			is_sorted :=
				across
					1 |..| (ns.count - 1) as i
				all
					ns[i.item] <= ns[i.item + 1]
				end
			Result := (is_sorted = false)
		end

	t2: BOOLEAN
		local
			c1, c2, c3, c4: DATA_CELL[INTEGER]
			l_comparator: DATA_CELL_COMPARATOR[INTEGER]
			l_sorter: DS_ARRAY_QUICK_SORTER[DATA_CELL[INTEGER]]
			cells: ARRAY[DATA_CELL[INTEGER]]
		do
			comment ("t2: sorting data cells")

			create c1.make (77)
			create c2.make (17)
			create c3.make (23)
			create c4.make (46)

			create cells.make_empty
			-- add c1, c2, c3, c4 into cells
			-- Exercise to write these updates

			create l_comparator
			create l_sorter.make (l_comparator)

			-- Exericse: before sorting, make sure cells are not sorted
			-- Hint: use across

			l_sorter.sort (cells)

			-- Exericse: after sorting, make sure cells are sorted
			-- Hint: use across


		end

end
